unit U_ContractList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ToolWin, cxStyles, cxCustomData,
  cxGraphics, cxFilter, cxData, cxDataStorage, cxEdit, DB, cxDBData, ADODB,
  cxGridCustomPopupMenu, cxGridPopupMenu, cxGridLevel, cxClasses, cxControls,
  cxGridCustomView, cxGridCustomTableView, cxGridTableView, cxGridDBTableView,
  cxGrid, DBClient, cxCheckBox, cxCalendar, cxSplitter, RM_Dataset, RM_System,
  RM_Common, RM_Class, RM_GridReport, RM_e_Xls, Menus, cxPC, cxButtonEdit,
  cxTextEdit, cxDropDownEdit, cxLookAndFeels, cxLookAndFeelPainters, dxSkinsCore,
  dxSkinsDefaultPainters, cxNavigator, dxDateRanges, dxBarBuiltInMenu,
  U_BaseList, RM_e_Graphic, RM_e_Jpeg, RM_E_llPDF, Vcl.Clipbrd, dxSkinWXI,
  dxScrollbarAnnotations;

type
  TfrmContractList = class(TfrmBaseList)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBAdd: TToolButton;
    TBEdit: TToolButton;
    TBPrint: TToolButton;
    TBClose: TToolButton;
    Tv1: TcxGridDBTableView;
    cxGrid1Level1: TcxGridLevel;
    cxGrid1: TcxGrid;
    GPM_1: TcxGridPopupMenu;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DS_1: TDataSource;
    v1OrdDate: TcxGridDBColumn;
    v1DeliveryDate: TcxGridDBColumn;
    v1OrdPerson1: TcxGridDBColumn;
    v1ConNo: TcxGridDBColumn;
    CDS_2: TClientDataSet;
    v1CustomerNoName: TcxGridDBColumn;
    ToolButton1: TToolButton;
    v1Column1: TcxGridDBColumn;
    ToolButton2: TToolButton;
    v1Column4: TcxGridDBColumn;
    pm2: TPopupMenu;
    Panel1: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    BuyName: TEdit;
    C_Name: TEdit;
    MPRTCodeName: TEdit;
    ConNo: TEdit;
    MPRTKZ: TEdit;
    MPRTMF: TEdit;
    cxTabControl1: TcxTabControl;
    tchk: TToolButton;
    Tnochk: TToolButton;
    cxSplitter1: TcxSplitter;
    DS_2: TDataSource;
    v1Column8: TcxGridDBColumn;
    Label2: TLabel;
    Tqx: TToolButton;
    Tnoqx: TToolButton;
    ToolButton5: TToolButton;
    v1Column10: TcxGridDBColumn;
    v1Column12: TcxGridDBColumn;
    v1Column9: TcxGridDBColumn;
    GPM_2: TcxGridPopupMenu;
    CDS_1: TClientDataSet;
    btnTijiao: TToolButton;
    btnCXTijiao: TToolButton;
    v1Column13: TcxGridDBColumn;
    Label3: TLabel;
    BuyConNo: TEdit;
    Tv1Column1: TcxGridDBColumn;
    Tv1Column2: TcxGridDBColumn;
    Tv1Column3: TcxGridDBColumn;
    Tv1Column4: TcxGridDBColumn;
    Tv1Column5: TcxGridDBColumn;
    Tv1Column6: TcxGridDBColumn;
    Tv1Column7: TcxGridDBColumn;
    Tv1Column14: TcxGridDBColumn;
    Label6: TLabel;
    HZSCSEName: TEdit;
    pm1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    btnWC: TToolButton;
    btnWCCX: TToolButton;
    Label7: TLabel;
    MiddleName: TEdit;
    ADOQueryImage: TADOQuery;
    Tv1Column19: TcxGridDBColumn;
    IsJYTime: TCheckBox;
    ToolButton7: TToolButton;
    N3: TMenuItem;
    N4: TMenuItem;
    Tv1Column25: TcxGridDBColumn;
    Tv1Column27: TcxGridDBColumn;
    cxGrid2: TcxGrid;
    TV2: TcxGridDBTableView;
    v1XHNo: TcxGridDBColumn;
    VC_SCSCode: TcxGridDBColumn;
    cxGridDBColumn2: TcxGridDBColumn;
    cxGridDBColumn3: TcxGridDBColumn;
    v1Column5: TcxGridDBColumn;
    cxGridDBColumn4: TcxGridDBColumn;
    cxGridDBColumn5: TcxGridDBColumn;
    cxGridDBColumn6: TcxGridDBColumn;
    cxGridDBColumn7: TcxGridDBColumn;
    cxGridDBColumn8: TcxGridDBColumn;
    v1Column6: TcxGridDBColumn;
    v1Column7: TcxGridDBColumn;
    v1PRTOrderQty: TcxGridDBColumn;
    v1OrderUnit: TcxGridDBColumn;
    v1PRTPrice: TcxGridDBColumn;
    cxGridDBColumn9: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    cxGridLevel1: TcxGridLevel;
    N5: TMenuItem;
    N6: TMenuItem;
    ToolButton3: TToolButton;
    ADOQuery1: TADOQuery;
    TV2Column1: TcxGridDBColumn;
    TV2Column2: TcxGridDBColumn;
    Tv1Column8: TcxGridDBColumn;
    Tv1Column9: TcxGridDBColumn;
    Tv1Column10: TcxGridDBColumn;
    Tv1Column11: TcxGridDBColumn;
    Tv1Column12: TcxGridDBColumn;
    Tv1Column13: TcxGridDBColumn;
    Tv1Column15: TcxGridDBColumn;
    Tv1Column16: TcxGridDBColumn;
    Tv1Column17: TcxGridDBColumn;
    Tv1Column18: TcxGridDBColumn;
    Tv1Column20: TcxGridDBColumn;
    Tv1Column21: TcxGridDBColumn;
    Tv1Column22: TcxGridDBColumn;
    Tv1Column23: TcxGridDBColumn;
    ToolButton4: TToolButton;
    Tv1Column24: TcxGridDBColumn;
    Tv1Column26: TcxGridDBColumn;
    Tv1Column28: TcxGridDBColumn;
    Tv1Column29: TcxGridDBColumn;
    Tv1Column30: TcxGridDBColumn;
    Tv1Column31: TcxGridDBColumn;
    Label1: TLabel;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBCloseClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure TBEditClick(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Tv1CellDblClick(Sender: TcxCustomGridTableView; ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton; AShift: TShiftState; var AHandled: Boolean);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure BuyNameChange(Sender: TObject);
    procedure tchkClick(Sender: TObject);
    procedure TnochkClick(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure Tv1FocusedRecordChanged(Sender: TcxCustomGridTableView; APrevFocusedRecord, AFocusedRecord: TcxCustomGridRecord; ANewItemRecordFocusingChanged: Boolean);
    procedure TqxClick(Sender: TObject);
    procedure TnoqxClick(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure Tv1CustomDrawCell(Sender: TcxCustomGridTableView; ACanvas: TcxCanvas; AViewInfo: TcxGridTableDataCellViewInfo; var ADone: Boolean);
    procedure btnTijiaoClick(Sender: TObject);
    procedure btnCXTijiaoClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure btnWCClick(Sender: TObject);
    procedure btnWCCXClick(Sender: TObject);
    procedure ConNoKeyPress(Sender: TObject; var Key: Char);
    procedure ToolButton7Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure TBPrintClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure Tv1DataControllerFilterChanged(Sender: TObject);
  private
    fFlileFlag: string;
    procedure InitGrid();
    procedure SetStatus();
    procedure InitSub();
    procedure InitImage();

    { Private declarations }
  public
    FFInt, FCloth: Integer;
    FAuthority, FGSTT, FSubIdS: string;
    { Public declarations }
  end;

implementation

uses
  U_DataLink, U_SalesConInPut, U_RTFun, U_AttachmentUpload, U_LabelPrint;

{$R *.dfm}

procedure TfrmContractList.InitImage();
begin

  ADOQueryImage.Close;
  if CDS_1.IsEmpty then
    exit;
  with ADOQueryImage do
  begin
    close;
    sql.Clear;
    sql.Add('select * from TP_File A');
    sql.Add('where WBID=' + quotedstr(trim(CDS_1.fieldbyname('SubId').AsString)));
    sql.Add('and TFType=' + quotedstr(trim('HX')));
    open;
  end;
end;

procedure TfrmContractList.InitSub();
begin

  with ADOQueryTemp do
  begin
    close;
    sql.Clear;
    sql.Add('select * from BS_Contract_sub A  ');
    sql.Add('where ConMID =' + quotedstr((CDS_1.fieldbyname('ConMID').AsString)));
    open;
  end;
  SCreateCDS(ADOQueryTemp, CDS_2);
  SInitCDSData(ADOQueryTemp, CDS_2);

  with ADOQuery1 do
  begin
    close;
    sql.Clear;
    sql.Add('select Top 1  CONVERT(float, RTValue) LR,RTValue  from BS_Contract_sub A  ');
    sql.Add('CROSS Apply  dbo.F_Tool_SplitString(isnull(A.profitrate,''0%''), ''%'')');
    sql.Add('where ConMID =' + quotedstr((CDS_1.fieldbyname('ConMID').AsString)));
    sql.Add('Order By LR  ');
//    ShowMessage(sql.text);
    open;
  end;
//  ShowMessage(ADOQuery1.fieldbyname('RTValue').AsString);
  if cxTabControl1.TabIndex = 1 then
  begin
    if ADOQuery1.IsEmpty = false then
    begin
      if Trim(FAuthority) = '录入' then
      begin

        if StrToFloat(ADOQuery1.fieldbyname('RTValue').AsString) > 8 then
        begin
          tchk.Enabled := True;
//      tnochk.Enabled := True;
        end
        else
        begin
          tchk.Enabled := False;
//      tnochk.Enabled := False;
        end;
      end;
    end;
//  end
//  else
//  begin
//    if ADOQuery1.IsEmpty = false then
//    begin
//      if Trim(FAuthority) = '录入' then
//      begin
//
//        if StrToInt(ADOQuery1.fieldbyname('RTValue').AsString) > 8 then
//        begin
////          tchk.Enabled := True;
//      tnochk.Enabled := True;
//        end
//        else
//        begin
////          tchk.Enabled := False;
//      tnochk.Enabled := False;
//        end;
//      end;
//    end;
  end;

  TV2.DataController.Filter.Clear;
end;

procedure TfrmContractList.N1Click(Sender: TObject);
begin
  SelOKNoFiler(Tv1, True); //全选
end;

procedure TfrmContractList.N2Click(Sender: TObject);
begin
  SelOKNoFiler(Tv1, False); //全弃
end;

procedure TfrmContractList.N3Click(Sender: TObject);
begin
  Clipboard.SetTextBuf(PChar(Trim(CDS_1.fieldbyname(TV1.Controller.FocusedColumn.DataBinding.FilterFieldName).AsString)));
end;

procedure TfrmContractList.N4Click(Sender: TObject);
begin
  Clipboard.SetTextBuf(PChar(Trim(CDS_1.fieldbyname(TV1.Controller.FocusedColumn.DataBinding.FilterFieldName).AsString)));
end;

procedure TfrmContractList.N5Click(Sender: TObject);
begin
  SelOKNo(CDS_1, True);
end;

procedure TfrmContractList.N6Click(Sender: TObject);
begin
  SelOKNo(CDS_1, False);

end;

procedure TfrmContractList.SetStatus();
begin
  TBAdd.Enabled := false;
  tbedit.Enabled := false;
  ToolButton2.Enabled := false;
  tchk.Enabled := false;
  tnochk.Enabled := false;
  Tqx.Enabled := false;
  TNoqx.Enabled := false;
  TBPrint.Enabled := False;
  btnTijiao.Enabled := False;
  btnCXTijiao.Enabled := False;
  btnWC.Enabled := False;
  btnWCCX.Enabled := False;
  ToolButton3.Enabled := false;

  if Trim(FAuthority) = '录入' then
  begin
    ToolButton2.Enabled := true;
    TBAdd.Enabled := true;
    TBPrint.Enabled := True;
    case cxTabControl1.TabIndex of
      0:
        begin
          tbedit.Enabled := true;
          Tqx.Enabled := True;
          btnTijiao.Enabled := True;
          ToolButton3.Enabled := True;
        end;
      1:
        begin
          tbedit.Enabled := True;
          btnCXTijiao.Enabled := True;
          ToolButton3.Enabled := True;
        end;
      2:
        begin
//          tbedit.Enabled := True;
          btnWC.Enabled := True;
          tnochk.Enabled := True;
        end;
      3:
        begin
          btnWCCX.Enabled := True;
        end;
      4:
        begin
          TNoqx.Enabled := True;
        end;
    end;
  end;
  if Trim(FAuthority) = '管理' then
  begin
    ToolButton2.Enabled := true;
    TBAdd.Enabled := true;
    TBPrint.Enabled := True;
    case cxTabControl1.TabIndex of
      0:
        begin
          tbedit.Enabled := true;
          Tqx.Enabled := true;
          btnTijiao.Enabled := True;
          ToolButton3.Enabled := True;
        end;
      1:
        begin
          tbedit.Enabled := True;
          btnCXTijiao.Enabled := True;
          tchk.Enabled := True;
          ToolButton3.Enabled := True;
        end;
      2:
        begin
//          tbedit.Enabled := True;
          tnochk.Enabled := True;
          btnWC.Enabled := True;
        end;
      3:
        begin
          btnWCCX.Enabled := True;
        end;
      4:
        begin
          TNoqx.Enabled := true;
        end;
    end;
  end;
  if Trim(FAuthority) = '查询' then
  begin
    TBPrint.Enabled := True;
  end;
end;

procedure TfrmContractList.FormDestroy(Sender: TObject);
begin
  inherited;
//  frmContractListNX:=nil;
end;

procedure TfrmContractList.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  Action := caFree;
end;

procedure TfrmContractList.FormCreate(Sender: TObject);
begin
  inherited;
  EndDate.DateTime := SGetServerDate(ADOQueryTemp);
  BegDate.DateTime := EndDate.DateTime - 90;

end;

procedure TfrmContractList.TBCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmContractList.InitGrid();
var
  WSql: string;
  FZMQty,FZKg,FUSDAmount,FCNYAmount: Double;
begin
  WSql := SGetFilters(Panel1, 1, 2);
  if trim(WSql) <> '' then
  begin
    WSql := ' and ' + trim(WSql);
  end;

  if IsJYTime.Checked then
  begin
    WSql := WSql + ' and ConDate>' + quotedstr(FormatDateTime('yyyy-MM-dd', BegDate.DateTime));
    WSql := WSql + ' and ConDate<=' + quotedstr(FormatDateTime('yyyy-MM-dd', enddate.DateTime + 1));
  end
  else
  begin
    if trim(WSql) <> '' then
      WSql := ' and 1=1' + trim(WSql)
    else
      WSql := WSql + ' and 1=2 ';
  end;
  if trim(WSql) = 'and 1=2' then
    Application.MessageBox('勾选制单日期或填入搜索条件', '提示', 0);

  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      sql.Clear;

      sql.Add('select IsFJ=cast((case when (select COUNT(FF.WBID) from FJ_File FF');
      sql.Add('where FF.TFType = ''合同'' and FF.WBID=AA.ConMID)=0 then 0 else 1 end) as bit )   ');
      SQL.Add(',STUFF( (SELECT  '';'' +X.CB_Name+X.CB_Price FROM Bs_Contract_Sub_CB X ');
      sql.Add('where X.ConSid= B.ConSid ORDER BY X.SerialNo  FOR XML PATH('''')),1, 1, '''') AS EstimatedCD  ');
      sql.Add(',Cast((Case ConUnit when ''M'' then B.ConQty when ''Y'' then B.ConQty*0.9144 else 0 end ) AS DECIMAL(18,2)) AS HZMQty');
      sql.Add(',Cast((Case ConUnit when ''Kg'' then B.ConQty  else 0 end ) AS DECIMAL(18,2)) AS HZKg');
      sql.Add(',Cast((Case Currency when ''CNY'' then B.ConTotalAmount  else 0 end ) AS DECIMAL(18,2)) AS CNYAmount');
      sql.Add(',Cast((Case Currency when ''USD'' then B.ConTotalAmount  else 0 end ) AS DECIMAL(18,2)) AS USDAmount');
      sql.Add(',AA.*,B.* from (select A.*,(Case A.Status when ''0'' then ''未提交'' when ''1'' then ''已提交''');
      sql.Add('when ''9'' then ''已审核'' when ''10'' then ''已完成'' when ''-1'' then ''已取消'' end) AS ZT');
      sql.Add('from BS_Contract_Main A  ) AA left join BS_Contract_Sub B on AA.ConMid=B.ConMid');
      sql.Add('where 1=1 ' + (WSql));
      sql.Add(' and AA.ConType in (''内销'',''外销'') ');

      if Trim(FAuthority) = '录入' then
      begin
        sql.Add(' and ( SalesId=' + quotedstr(trim(DCode)) + ' or Filler =' + quotedstr(trim(DCode)) + ' or exists (select * from [dbo].[F_Tool_SplitString](TallyId,'','') X where X.RTValue =' + quotedstr(trim(DCode)) + '))');
      end;

      case cxTabControl1.TabIndex of
        0:
          begin
            sql.Add(' and  isnull(AA.status,''0'')=''0''');
          end;
        1:
          begin
            sql.Add(' and  isnull(AA.status,''0'')=''1''');
          end;
        2:
          begin
            sql.Add(' and  isnull(AA.status,''0'')=''9''');
          end;
        3:
          begin
            sql.Add(' and  isnull(AA.status,''0'')=''10''');
          end;
        4:
          begin
            sql.Add(' and  isnull(AA.status,''0'')=''-1''');
          end;
      end;
//      ShowMessage(sql.text);
      Open;
    end;
    SCreateCDS(ADOQueryMain, CDS_1);
    SInitCDSData(ADOQueryMain, CDS_1);
  finally
    ADOQueryMain.EnableControls;
    TV1.DataController.Filter.Clear;

  end;

   if ADOQueryMain.IsEmpty = False then
  begin
    FZMQty := tv1.DataController.Summary.FooterSummaryValues[2];
    FZKg := tv1.DataController.Summary.FooterSummaryValues[3];
    FCNYAmount := tv1.DataController.Summary.FooterSummaryValues[4];
    FUSDAmount := tv1.DataController.Summary.FooterSummaryValues[5];

    Label1.Caption := '总米数：' + FloatToStr(FZMQty) + '    总公斤数：' + FloattoStr(FZKg) + '    CNY金额：' + FloattoStr(FCNYAmount)+ '    USD金额：' + FloattoStr(FUSDAmount);
  end;
end;

procedure TfrmContractList.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active = False then
    Exit;
  SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
  SCreateCDS(ADOQueryMain, CDS_1);
  SInitCDSData(ADOQueryMain, CDS_1);
end;

procedure TfrmContractList.TBPrintClick(Sender: TObject);
var
  WSql: string;
begin
  if CDS_1.IsEmpty then
    Exit;

  try
    frmLabelPrint := TfrmLabelPrint.Create(Application);
    with frmLabelPrint do
    begin
      FLMType := 'SalesConPrint';
      FFiltration1 := QuotedStr(Trim(Self.CDS_1.fieldbyname('ConMID').AsString));
      if ShowModal = 1 then
      begin
//        Self.InitGrid();
      end;
    end;
  finally
    frmLabelPrint.Free;
  end;

end;

procedure TfrmContractList.TBEditClick(Sender: TObject);
begin
  if CDS_1.IsEmpty then
    Exit;
//  ShowMessage(Trim(CDS_1.fieldbyname('Filler').AsString));
//  ShowMessage(Trim(DName));
//  if Trim(CDS_1.fieldbyname('Filler').AsString) <> Trim(DName) then
//  begin
//    Application.MessageBox('不能操作他人的数据!', '提示', 0);
//    Exit;
//  end;
  try
    frmSalesConInPut := TfrmSalesConInPut.Create(Application);
    with frmSalesConInPut do
    begin
      PState := '修改';
      FConMId := Trim(Self.CDS_1.fieldbyname('ConMID').AsString);
      FAuthority := self.FAuthority;
      FGSTT := self.FGSTT;
      fFlileFlag := self.fFlileFlag;
      if ShowModal = 1 then
      begin

      end;
    end;
  finally
    frmSalesConInPut.Free;
  end;
end;

procedure TfrmContractList.TBRafreshClick(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmContractList.TBAddClick(Sender: TObject);
var
  maxno: string;
begin
  try
    frmSalesConInPut := TfrmSalesConInPut.Create(Application);
    with frmSalesConInPut do
    begin
      PState := '新增';
      FConMId := '';
      FAuthority := self.FAuthority;
      FGSTT := self.FGSTT;
      fFlileFlag := self.fFlileFlag;
      if ShowModal = 1 then
      begin

      end;
    end;
  finally
    frmSalesConInPut.Free;
  end;
end;

procedure TfrmContractList.FormShow(Sender: TObject);
begin
  inherited;
  fFlileFlag := UserDataFlag + 'HX';
  FAuthority := self.fParameters1;
  readCxGrid(trim(Self.Caption) + 'tv1', Tv1, '销售合同管理');
  readCxGrid(trim(Self.Caption) + 'tv2', Tv2, '销售合同管理');

  SetStatus();
  InitGrid();
end;

procedure TfrmContractList.Tv1CellDblClick(Sender: TcxCustomGridTableView; ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton; AShift: TShiftState; var AHandled: Boolean);
begin
  if ToolButton1.Visible = False then
    Exit;
  ToolButton1.Click;
end;

procedure TfrmContractList.CheckBox1Click(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmContractList.CheckBox2Click(Sender: TObject);
begin
  TBRafresh.Click;
end;

procedure TfrmContractList.ConNoKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    InitGrid();
  end;
end;

procedure TfrmContractList.ToolButton1Click(Sender: TObject);
begin
  if CDS_1.IsEmpty then
    Exit;
  try
    frmSalesConInPut := TfrmSalesConInPut.Create(Application);
    with frmSalesConInPut do
    begin
      PState := '查看';
      FConMId := Trim(Self.CDS_1.fieldbyname('ConMID').AsString);
      FGSTT := self.FGSTT;
      ToolBar2.Visible := False;
      TBSave.Visible := False;
//      ScrollBox1.Enabled := False;
      if ShowModal = 1 then
      begin

      end;
    end;
  finally
    frmSalesConInPut.Free;
  end;
end;

procedure TfrmContractList.ToolButton2Click(Sender: TObject);
begin
  if CDS_1.IsEmpty then
    Exit;
  try
    frmSalesConInPut := TfrmSalesConInPut.Create(Application);
    with frmSalesConInPut do
    begin
      PState := '复制';
      FConMId := Trim(Self.CDS_1.fieldbyname('ConMID').AsString);
      FAuthority := self.FAuthority;
      fFlileFlag := self.fFlileFlag;
      if ShowModal = 1 then
      begin

      end;
    end;
  finally
    frmSalesConInPut.Free;
  end;
end;

procedure TfrmContractList.ToolButton3Click(Sender: TObject);
begin
  if CDS_1.IsEmpty then
    Exit;
//  ShowMessage(Trim(CDS_1.fieldbyname('Filler').AsString));
//  ShowMessage(Trim(DName));
//  if Trim(CDS_1.fieldbyname('Filler').AsString) <> Trim(DName) then
//  begin
//    Application.MessageBox('不能操作他人的数据!', '提示', 0);
//    Exit;
//  end;
  try
    frmSalesConInPut := TfrmSalesConInPut.Create(Application);
    with frmSalesConInPut do
    begin
      PState := '成本预估';
      FConMId := Trim(Self.CDS_1.fieldbyname('ConMID').AsString);
      FAuthority := self.FAuthority;
      FGSTT := self.FGSTT;
      fFlileFlag := self.fFlileFlag;
      panel2.Visible := True;
      ToolButton4.Visible := False;
      ToolButton5.Visible := False;
      if ShowModal = 1 then
      begin

      end;
    end;
  finally
    frmSalesConInPut.Free;
  end;

end;

procedure TfrmContractList.ToolButton4Click(Sender: TObject);
begin
   if CDS_1.IsEmpty then
    Exit;
  TcxGridToExcel(self.Caption, cxGrid1);

end;

procedure TfrmContractList.btnWCClick(Sender: TObject);
var
  MConMIDS: string;
begin
  if CDS_1.IsEmpty then
    exit;
  if CDS_1.FieldByName('ISFJ').AsBoolean=False then
  begin
     application.MessageBox('请上传附件后完成合同', '提示');
     Exit;
  end;
//  if not CDS_1.Locate('SSel', True, []) then
//  begin
//    application.MessageBox('请选择数据', '提示');
//    Exit;
//  end;
//  with CDS_1 do
//  begin
//    DisableControls;
//    First;
//    MConMIDS := '';
//    while not eof do
//    begin
//      if fieldbyname('SSel').AsBoolean then
//      begin
//        MConMIDS := MConMIDS + trim(fieldbyname('ConMID').AsString) + ',';
//      end;
//      next;
//    end;
//    MConMIDS := copy(MConMIDS, 1, Length(MConMIDS) - 1);
//    EnableControls;
//  end;
  MConMIDS := CDS_1.fieldbyname('ConMID').AsString;
  try
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add(' exec P_BS_Contract_SetStatus ');
      sql.Add(' @ConMIDS=' + QuotedStr(MConMIDS));
      sql.Add(',@Operation=''完成'' ');
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));

      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' ' + quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(',' + quotedstr(trim(self.Caption)));
      sql.Add(',' + quotedstr(trim('合同完成')));
      sql.Add(',' + quotedstr(trim('合同ID：' + trim(MConMIDS))));
      sql.Add(',' + quotedstr(trim('成功')));
      sql.Add(')');
      open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
    application.MessageBox('完成成功', '提示');
    InitGrid();
  except
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    InitGrid();
  end;

end;

procedure TfrmContractList.BuyNameChange(Sender: TObject);
begin
  if ADOQueryMain.Active = False then
    Exit;
  SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
  SCreateCDS(ADOQueryMain, CDS_1);
  SInitCDSData(ADOQueryMain, CDS_1);
end;

procedure TfrmContractList.tchkClick(Sender: TObject);
var
  MConMIDS: string;
begin
  if CDS_1.IsEmpty then
    exit;
  MConMIDS := MConMIDS + CDS_1.fieldbyname('ConMID').AsString + ',';
//  if not CDS_1.Locate('SSel', True, []) then
//  begin
//    application.MessageBox('请选择数据', '提示');
//    Exit;
//  end;
//  with CDS_1 do
//  begin
//    DisableControls;
//    First;
//    MConMIDS := '';
//    while not eof do
//    begin
//      if fieldbyname('SSel').AsBoolean then
//      begin
//        MConMIDS := MConMIDS + trim(fieldbyname('ConMID').AsString) + ',';
//      end;
//      next;
//    end;
//    MConMIDS := copy(MConMIDS, 1, Length(MConMIDS) - 1);
//    EnableControls;
//  end;

  try
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add(' exec P_BS_Contract_SetStatus ');
      sql.Add(' @ConMIDS=' + QuotedStr(MConMIDS));
      sql.Add(',@Operation=''审核'' ');
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));

      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' ' + quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(',' + quotedstr(trim(self.Caption)));
      sql.Add(',' + quotedstr(trim('合同审核')));
      sql.Add(',' + quotedstr(trim('合同ID：' + trim(MConMIDS))));
      sql.Add(',' + quotedstr(trim('成功')));
      sql.Add(')');
      open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
    application.MessageBox('审核成功', '提示');
    InitGrid();
  except
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    InitGrid();
  end;

end;

procedure TfrmContractList.TnochkClick(Sender: TObject);
var
  MConMIDS: string;
begin
  if CDS_1.IsEmpty then
    exit;
  MConMIDS := MConMIDS + CDS_1.fieldbyname('ConMID').AsString + ',';
//  if not CDS_1.Locate('SSel', True, []) then
//  begin
//    application.MessageBox('请选择数据', '提示');
//    Exit;
//  end;
//  with CDS_1 do
//  begin
//    DisableControls;
//    First;
//    MConMIDS := '';
//    while not eof do
//    begin
//      if fieldbyname('SSel').AsBoolean then
//      begin
//        MConMIDS := MConMIDS + trim(fieldbyname('ConMID').AsString) + ',';
//      end;
//      next;
//    end;
//    MConMIDS := copy(MConMIDS, 1, Length(MConMIDS) - 1);
//    EnableControls;
//  end;

  try
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add(' exec P_BS_Contract_SetStatus ');
      sql.Add(' @ConMIDS=' + QuotedStr(MConMIDS));
      sql.Add(',@Operation=''撤销审核'' ');
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));

      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' ' + quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(',' + quotedstr(trim(self.Caption)));
      sql.Add(',' + quotedstr(trim('合同撤销审核')));
      sql.Add(',' + quotedstr(trim('合同ID：' + trim(MConMIDS))));
      sql.Add(',' + quotedstr(trim('成功')));
      sql.Add(')');
      open;
    end;

    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
    application.MessageBox('撤销审核成功', '提示');
    InitGrid();
  except
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    InitGrid();
  end;

end;

procedure TfrmContractList.cxTabControl1Change(Sender: TObject);
begin
  SetStatus();
  TBRafresh.Click;
end;

procedure TfrmContractList.Tv1FocusedRecordChanged(Sender: TcxCustomGridTableView; APrevFocusedRecord, AFocusedRecord: TcxCustomGridRecord; ANewItemRecordFocusingChanged: Boolean);
begin
//  if CDS_1.IsEmpty then
//    exit;
//  InitSub();
end;

procedure TfrmContractList.TqxClick(Sender: TObject);
var
  MConMIDS: string;
begin
  if CDS_1.IsEmpty then
    exit;
  if not CDS_1.Locate('SSel', True, []) then
  begin
    application.MessageBox('请选择数据', '提示');
    Exit;
  end;
  with CDS_1 do
  begin
    DisableControls;
    First;
    MConMIDS := '';
    while not eof do
    begin
      if fieldbyname('SSel').AsBoolean then
      begin
        MConMIDS := MConMIDS + trim(fieldbyname('ConMID').AsString) + ',';
      end;
      next;
    end;
    MConMIDS := copy(MConMIDS, 1, Length(MConMIDS) - 1);
    EnableControls;
  end;

  try
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add(' exec P_BS_Contract_SetStatus ');
      sql.Add(' @ConMIDS=' + QuotedStr(MConMIDS));
      sql.Add(',@Operation=''取消'' ');
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));

      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' ' + quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(',' + quotedstr(trim(self.Caption)));
      sql.Add(',' + quotedstr(trim('合同取消')));
      sql.Add(',' + quotedstr(trim('合同ID：' + trim(MConMIDS))));
      sql.Add(',' + quotedstr(trim('成功')));
      sql.Add(')');
      open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
    application.MessageBox('取消成功', '提示');
    InitGrid();
  except
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    InitGrid();
  end;

end;

procedure TfrmContractList.TnoqxClick(Sender: TObject);
var
  MConMIDS: string;
begin
  if CDS_1.IsEmpty then
    exit;
  if not CDS_1.Locate('SSel', True, []) then
  begin
    application.MessageBox('请选择数据', '提示');
    Exit;
  end;
  with CDS_1 do
  begin
    DisableControls;
    First;
    MConMIDS := '';
    while not eof do
    begin
      if fieldbyname('SSel').AsBoolean then
      begin
        MConMIDS := MConMIDS + trim(fieldbyname('ConMID').AsString) + ',';
      end;
      next;
    end;
    MConMIDS := copy(MConMIDS, 1, Length(MConMIDS) - 1);
    EnableControls;
  end;

  try
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' ' + quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(',' + quotedstr(trim(self.Caption)));
      sql.Add(',' + quotedstr(trim('合同撤销取消')));
      sql.Add(',' + quotedstr(trim('合同ID：' + trim(MConMIDS))));
      sql.Add(',' + quotedstr(trim('成功')));
      sql.Add(')');

      sql.Add(' exec P_BS_Contract_SetStatus ');
      sql.Add(' @ConMIDS=' + QuotedStr(MConMIDS));
      sql.Add(',@Operation=''撤销取消'' ');
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));
//      ShowMessage(sql.Text);
      open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
    application.MessageBox('撤销取消成功', '提示');
    InitGrid();
  except
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    InitGrid();
  end;

end;

procedure TfrmContractList.ToolButton5Click(Sender: TObject);
begin
  if CDS_1.IsEmpty then
    Exit;
  try
    frmAttachmentUpload := TfrmAttachmentUpload.Create(Application);
    with frmAttachmentUpload do
    begin
       FEditAuthority := True;
      fkeyNO := Trim(Self.CDS_1.fieldbyname('ConMID').AsString);
      fType := '合同';
      if ShowModal = 1 then
      begin

      end;
    end;
  finally
    frmAttachmentUpload.Free;
  end;
end;

procedure TfrmContractList.ToolButton7Click(Sender: TObject);
begin
  writeCxGrid(trim(Self.Caption) + 'tv1', Tv1, '销售合同管理');
  writeCxGrid(trim(Self.Caption) + 'tv2', Tv2, '销售合同管理');
end;

procedure TfrmContractList.btnWCCXClick(Sender: TObject);
var
  MConMIDS: string;
begin
  if CDS_1.IsEmpty then
    exit;
  if not CDS_1.Locate('SSel', True, []) then
  begin
    application.MessageBox('请选择数据', '提示');
    Exit;
  end;
  with CDS_1 do
  begin
    DisableControls;
    First;
    MConMIDS := '';
    while not eof do
    begin
      if fieldbyname('SSel').AsBoolean then
      begin
        MConMIDS := MConMIDS + trim(fieldbyname('ConMID').AsString) + ',';
      end;
      next;
    end;
    MConMIDS := copy(MConMIDS, 1, Length(MConMIDS) - 1);
    EnableControls;
  end;

  try
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add(' exec P_BS_Contract_SetStatus ');
      sql.Add(' @ConMIDS=' + QuotedStr(MConMIDS));
      sql.Add(',@Operation=''撤销完成'' ');
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));

      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' ' + quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(',' + quotedstr(trim(self.Caption)));
      sql.Add(',' + quotedstr(trim('合同撤销完成')));
      sql.Add(',' + quotedstr(trim('合同ID：' + trim(MConMIDS))));
      sql.Add(',' + quotedstr(trim('成功')));
      sql.Add(')');
      open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
    application.MessageBox('撤销完成成功', '提示');
    InitGrid();
  except
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    InitGrid();
  end;

end;

procedure TfrmContractList.Tv1CustomDrawCell(Sender: TcxCustomGridTableView; ACanvas: TcxCanvas; AViewInfo: TcxGridTableDataCellViewInfo; var ADone: Boolean);
begin
  if AViewInfo.GridRecord.Values[tv1.GetColumnByFieldName('status').Index] = '2' then
    ACanvas.Brush.Color := clLime;
  if cxTabControl1.TabIndex=5 then
  begin
  if AViewInfo.GridRecord.Values[tv1.GetColumnByFieldName('status').Index] = '-1' then
    ACanvas.Brush.Color := clBtnShadow;
  end;
end;


procedure TfrmContractList.Tv1DataControllerFilterChanged(Sender: TObject);
var
  FZMQty, FZKg, FCNYAmount, FUSDAmount: Double;
begin
  if ADOQueryMain.IsEmpty = False then
  begin
    FZMQty := tv1.DataController.Summary.FooterSummaryValues[2];
    FZKg := tv1.DataController.Summary.FooterSummaryValues[3];
    FCNYAmount := tv1.DataController.Summary.FooterSummaryValues[4];
    FUSDAmount := tv1.DataController.Summary.FooterSummaryValues[5];

    Label1.Caption := '总米数：' + FloatToStr(FZMQty) + '    总公斤数：' + FloattoStr(FZKg) + '    CNY金额：' + FloattoStr(FCNYAmount)+ '    USD金额：' + FloattoStr(FUSDAmount);
  end;

end;

procedure TfrmContractList.btnTijiaoClick(Sender: TObject);
var
  MConMIDS: string;
  i:Integer;
begin
  if CDS_1.IsEmpty then
    exit;
  if not CDS_1.Locate('SSel', True, []) then
  begin
    application.MessageBox('请选择数据', '提示');
    Exit;
  end;

  with ADOQuery1 do
  begin
     Close;
      sql.Clear;
      sql.Add('select Count(ConSid) CS from BS_Contract_Sub');
      sql.add(' where ConMid=' + QuotedStr(TRIM(CDS_1.FieldByName('ConMid').AsString)));
      sql.add('and isnull(Estimated,'''')=''''');
//      ShowMessage(Sql.text);
      open;
  end;

  i :=Strtoint(ADOQuery1.FieldByName('CS').AsString);

//  ShowMessage(ADOQuery1.FieldByName('CS').AsString);
  if  i>0 then
  begin
     application.MessageBox('请先预估成本价后再提交！', '提示');
     Exit
  end;
//   if not CDS_2.Locate('Estimated', True, []) then
//  begin
//    application.MessageBox('请选择数据', '提示');
//    Exit;
//  end;

  with CDS_1 do
  begin
    DisableControls;
    First;
    MConMIDS := '';
    while not eof do
    begin
      if fieldbyname('SSel').AsBoolean then
      begin
        MConMIDS := MConMIDS + trim(fieldbyname('ConMID').AsString) + ',';
      end;
      next;
    end;
    MConMIDS := copy(MConMIDS, 1, Length(MConMIDS) - 1);
    EnableControls;
  end;

  try
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add(' exec P_BS_Contract_SetStatus ');
      sql.Add(' @ConMIDS=' + QuotedStr(MConMIDS));
      sql.Add(',@Operation=''提交'' ');
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));

      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' ' + quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(',' + quotedstr(trim(self.Caption)));
      sql.Add(',' + quotedstr(trim('内销合同提交')));
      sql.Add(',' + quotedstr(trim('合同ID：' + trim(MConMIDS))));
      sql.Add(',' + quotedstr(trim('成功')));
      sql.Add(')');
      open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
    application.MessageBox('提交成功', '提示');
    InitGrid();
  except
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    InitGrid();
  end;

end;

procedure TfrmContractList.btnCXTijiaoClick(Sender: TObject);
var
  MConMIDS: string;
begin
  if CDS_1.IsEmpty then
    exit;
  if not CDS_1.Locate('SSel', True, []) then
  begin
    application.MessageBox('请选择数据', '提示');
    Exit;
  end;
  with CDS_1 do
  begin
    DisableControls;
    First;
    MConMIDS := '';
    while not eof do
    begin
      if fieldbyname('SSel').AsBoolean then
      begin
        MConMIDS := MConMIDS + trim(fieldbyname('ConMID').AsString) + ',';
      end;
      next;
    end;
    MConMIDS := copy(MConMIDS, 1, Length(MConMIDS) - 1);
    EnableControls;
  end;

  try
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add(' exec P_BS_Contract_SetStatus ');
      sql.Add(' @ConMIDS=' + QuotedStr(MConMIDS));
      sql.Add(',@Operation=''撤销提交'' ');
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));

      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' ' + quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(',' + quotedstr(trim(self.Caption)));
      sql.Add(',' + quotedstr(trim('内销合同撤销提交')));
      sql.Add(',' + quotedstr(trim('合同ID：' + trim(MConMIDS))));
      sql.Add(',' + quotedstr(trim('成功')));
      sql.Add(')');
      open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
    application.MessageBox('撤销提交成功', '提示');
    InitGrid();
  except
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    InitGrid();
  end;

end;

end.

